/*************************** bittorrent_coding.h *************************/
vector<int> sc_all_chunks_;

class sc_our_node_;
vector<sc_our_node_ *> sc_list_nodes_;   

struct sc_our_node_ {
public:
  sc_our_node_();
  ~sc_our_node_();

  int id_, candidate; 
  double x, y; 
  vector<int> list_neighbors_, interested;
  vector<galois::GaloisFieldElement> full_comb;
  vector< vector<galois::GaloisFieldElement> > list_chunks_, just_received_;

  int independence_();
  int independent_nodes();
};

sc_our_node_::sc_our_node_() {
  this->id_ = 0;
  this->candidate = 0;
  this->x = 0;
  this->y = 0;
  this->full_comb.clear();
  this->interested.clear();
  this->list_chunks_.clear();
  this->list_neighbors_.clear();
  this->just_received_.clear();
}

sc_our_node_::~sc_our_node_() {
  this->id_ = 0;
  this->candidate = 0;
  this->x = 0;
  this->y = 0;
  this->full_comb.clear();
  this->interested.clear();
  this->list_chunks_.clear();
  this->list_neighbors_.clear();
  this->just_received_.clear();
} 

int sc_our_node_::independence_() {
  if (this->list_chunks_.size() == 0) {
    return 1;
  }

  int i, j, p, q;
  const int m=this->list_chunks_.size()+1, n=nb_chunks_;
  vector< vector<galois::GaloisFieldElement> > check_list_;
  for (i=0; i<m-1; i++) {
    check_list_.push_back(this->list_chunks_[i]);
  }
  check_list_.push_back(this->just_received_[0]);

  i=0;
  j=0;
  while ((i < m) && (j < n) ) {
    galois::GaloisFieldElement max_val = check_list_[i][j];
    int max_ind = i;
    int k;
    if (max_val == 0) {
      for (k=i+1; k<m; k++) {
	galois::GaloisFieldElement val = check_list_[k][j];
	if (val > max_val) {
	  max_val = val;
	  max_ind = k;
	  break;
	}
      }
    }
    if (max_val != 0) {
      if (max_ind != i) {
 	vector< vector<galois::GaloisFieldElement> > temp_;
 	temp_.push_back(check_list_[i]);
 	temp_.push_back(check_list_[max_ind]);
 	for (p=0; p<n; p++) {
 	  check_list_[max_ind][p] = temp_[0][p];
 	  check_list_[i][p] = temp_[1][p];
 	}
      }
      for (q=i+1; q<m; q++) {
	galois::GaloisFieldElement toto_(&gf, 0);
	toto_ = check_list_[q][j];
	for (p=j; p<n; p++) {
	  galois::GaloisFieldElement tata1(&gf, 0);
	  tata1 = check_list_[i][p]/check_list_[i][j];
	  galois::GaloisFieldElement tata2(&gf, 0);
	  tata2 = toto_*tata1;
	  check_list_[q][p] = check_list_[q][p] - tata2;
	}
      }
      i = i + 1;
    }
    j = j + 1;
  }

  int rank_ = 0;
  for (i=0; i<m; i++) {
    for (j=0; j<n; j++) {
      if (check_list_[i][j] != 0) {
	rank_++; 
	break;
      }
    }
  }
  if (rank_ == m) {return 1;}
  else {return 0;}
}

int sc_our_node_::independent_nodes() {
  bool keep_node_ = false;
  for (int i=0; i<this->list_neighbors_.size(); i++) {
    sc_our_node_ * neighbor_;
    neighbor_ = sc_list_nodes_[this->list_neighbors_[i]];
    if (neighbor_->list_chunks_.size() < nb_chunks_) {
      neighbor_->just_received_.clear();
      neighbor_->just_received_.push_back(this->full_comb);

      if (neighbor_->independence_() == 1) {
	keep_node_ = true;
	this->interested.push_back(neighbor_->id_);
      }
      neighbor_->just_received_.clear();
    }
  }

  if (keep_node_ == false) {return 0;}
  else {return 1;}
}

void sc_create_nodes_() {
  for (int i=0; i<nb_nodes_; i++) {
    sc_our_node_ *new_node_ = new sc_our_node_();
    new_node_->id_ = i;
    sc_list_nodes_.push_back(new_node_);
    if (
	((nb_sources == 1) && i!=source1->id_) || 
	((nb_sources == 2) && i!=source1->id_ && i!=source2->id_) || 
	((nb_sources == 3) && i!=source1->id_ && i!=source2->id_ && i!=source3->id_) || 
	((nb_sources == 4) && i!=source1->id_ && i!=source2->id_ && i!=source3->id_ && i!=source4->id_) 
	) {
      missing_nodes_.push_back(i);
      for (int j=0; j<nb_chunks_; j++) {
	galois::GaloisFieldElement x(&gf, 0);
	new_node_->full_comb.push_back(x);
      }
    }
    else {
      candidates_queue_.push_back(i);
      new_node_->candidate = 1;
      vector<galois::GaloisFieldElement> list_coef_;
      for (int j=0; j<nb_chunks_; j++) {
	galois::GaloisFieldElement x(&gf, 0);
	list_coef_.push_back(x);
      }
      for (int j=0; j<nb_chunks_; j++) {
	new_node_->list_chunks_.push_back(list_coef_);
      }
    }
  }
}

void sc_generate_xy() {
  sc_our_node_ * node1;
  node_xy * node2;

  for (int i=0; i<nb_nodes_; i++) {
    node1 = sc_list_nodes_[i];
    node2 = list_xy[i];
    node1->x = node2->x;
    node1->y = node2->y;
    for (int j=0; j<node2->list_neighbors_.size(); j++) {
      node1->list_neighbors_.push_back(node2->list_neighbors_[j]);
    }
  }
}

void  sc_select_transmitters() {
  vector<int>::iterator iter_int_;
  vector<int> potential_transmitters_;
  
  potential_transmitters_ = candidates_queue_;  
  
  while (potential_transmitters_.size() > 0) {
    int j = int((double(rand())/RAND_MAX)*potential_transmitters_.size());
    int k = potential_transmitters_[j];
    sc_our_node_ * selected_node_;
    selected_node_ = sc_list_nodes_[k];

    selected_node_->full_comb.clear();

    if (
	((nb_sources == 1) && selected_node_->id_==source1->id_) || 
	((nb_sources == 2) && (selected_node_->id_==source1->id_ || selected_node_->id_==source2->id_)) || 
	((nb_sources == 3) && (selected_node_->id_==source1->id_ || selected_node_->id_==source2->id_ || selected_node_->id_==source3->id_)) || 
	((nb_sources == 4) && (selected_node_->id_==source1->id_ || selected_node_->id_==source2->id_ || selected_node_->id_==source3->id_ || selected_node_->id_==source4->id_)) 
	) {
      for (int x=0; x<nb_chunks_; x++){ 
	double tompo = (double(rand())/RAND_MAX)*CODING_SPACE + 1;
	int temp1 = int(tompo);
	galois::GaloisFieldElement temp_(&gf, temp1);
	selected_node_->full_comb.push_back(temp_);
      }
    } 
    else {
      vector<galois::GaloisFieldElement> rand_coef_;
      rand_coef_.clear();
      int p,q;
      for (q=0; q<selected_node_->list_chunks_.size(); q++) {
	double tompo = (double(rand())/RAND_MAX)*CODING_SPACE + 1;
	int temp1 = int(tompo);
	galois::GaloisFieldElement temp_(&gf, temp1);
	rand_coef_.push_back(temp_);
      }
      for (q=0; q<nb_chunks_; q++) {
	galois::GaloisFieldElement tata_(&gf, 0);
	for (p=0; p<selected_node_->list_chunks_.size(); p++) {
	  tata_ = tata_ + rand_coef_[p]*selected_node_->list_chunks_[p][q];
	}
	selected_node_->full_comb.push_back(tata_);
      }
    }
    if (selected_node_->independent_nodes() == 0) {
      vector<int>::iterator start = candidates_queue_.begin();
      vector<int>::iterator end = candidates_queue_.end();
      iter_int_ = find(start, end, selected_node_->id_);
      candidates_queue_.erase(iter_int_);
      selected_node_->candidate = 0;
      start = potential_transmitters_.begin();
      end = potential_transmitters_.end();
      iter_int_ = find(start, end, selected_node_->id_);
      potential_transmitters_.erase(iter_int_);
    }
    else {
      ready_queue_.push_back(selected_node_->id_);
      vector<int>::iterator start;
      vector<int>::iterator end;
      
      vector<int> to_remove;
      to_remove.clear();
      to_remove.push_back(selected_node_->id_);
      for (j=0;j<selected_node_->list_neighbors_.size(); j++) {
	int neighbor_id = selected_node_->list_neighbors_[j];
	sc_our_node_ * neighbor_ = sc_list_nodes_[neighbor_id];
	start = to_remove.begin();
	end = to_remove.end();
	iter_int_ = find(start, end, neighbor_id);
	if (iter_int_ == to_remove.end()) {to_remove.push_back(neighbor_id);}
	for (k=0;k<neighbor_->list_neighbors_.size(); k++) {
	  int new_id = neighbor_->list_neighbors_[k];
	  start = to_remove.begin();
	  end = to_remove.end();
	  iter_int_ = find(start, end, new_id);
	  if (iter_int_ == to_remove.end()) {to_remove.push_back(new_id);}
	}
      }      
      while(to_remove.size() > 0) {
	int removed_node = to_remove[0];
	iter_int_ = to_remove.begin();
	to_remove.erase(iter_int_);
	start = potential_transmitters_.begin();
	end = potential_transmitters_.end();
	iter_int_ = find(start, end, removed_node);
	if (iter_int_ != potential_transmitters_.end()) {potential_transmitters_.erase(iter_int_);}
      }
    }
  }
  potential_transmitters_.clear();
}

void sc_perform_transmission() {
  vector<int>::iterator iter_int_;
  while (ready_queue_.size() > 0) {
    int j, k, q;
    sc_our_node_ * transmitter_;
    
    j = ready_queue_[0];
    iter_int_ = ready_queue_.begin();
    ready_queue_.erase(iter_int_);

    transmitter_ = sc_list_nodes_[j];
    packet_emitted++;
    packet_received = packet_received + transmitter_->list_neighbors_.size();

    vector<galois::GaloisFieldElement> transmitted_chunk_, rand_coef_;

    if (transmitter_->list_chunks_.size() == 1) {
      for (q=0; q<nb_chunks_; q++){ 
	transmitted_chunk_.push_back(transmitter_->list_chunks_[0][q]);
      }
    }
    else {
      for (q=0; q<nb_chunks_; q++){ 
	transmitted_chunk_.push_back(transmitter_->full_comb[q]);
      }
      transmitter_->full_comb.clear();
    }
    for (j=0; j<transmitter_->interested.size(); j++) {
      int proba = int((double(rand())/RAND_MAX)*100.0 + 1);
      if (proba > losses) {
	int neighbor_id_ = transmitter_->interested[j];
	sc_our_node_ * neighbor_ = sc_list_nodes_[neighbor_id_];
	packet_useful++; 
	int chunk_stat = neighbor_->list_chunks_.size();  
	all_chunks_[chunk_stat] = all_chunks_[chunk_stat] - 1;  
	neighbor_->list_chunks_.push_back(transmitted_chunk_); 
	chunk_stat = neighbor_->list_chunks_.size();  
	all_chunks_[chunk_stat] = all_chunks_[chunk_stat] + 1;  
	if (neighbor_->list_chunks_.size() == nb_chunks_) {
	  vector<int>::iterator start = missing_nodes_.begin();
	  vector<int>::iterator end = missing_nodes_.end();
	  iter_int_ = find(start, end, neighbor_id_);
	  if (iter_int_ != missing_nodes_.end()) {
	    missing_nodes_.erase(iter_int_);
	  }
	}
	int tata = neighbor_->list_chunks_.size();
	for (k=0; k<nb_chunks_; k++) {
	  neighbor_->full_comb[k] = neighbor_->full_comb[k] + neighbor_->list_chunks_[tata-1][k];
	}
	if (neighbor_->candidate == 0) {
	  neighbor_->candidate = 1;
	  candidates_queue_.push_back(neighbor_id_);
	}
      }
    }
    transmitter_->interested.clear();
  }
}

void run_selective_coding() {
  service_time = 0;
  packet_emitted = 0;
  packet_received = 0;
  packet_useful = 0;
  packet_useless = 0;
  all_chunks_.clear();

  missing_nodes_.clear();
  ready_queue_.clear();
  candidates_queue_.clear();
  receiving_queue_.clear();
  sc_list_nodes_.clear();
  all_chunks_.push_back(nb_nodes_-1);
  for (int a=1; a<nb_chunks_; a++) {
    all_chunks_.push_back(0);
  }
  all_chunks_.push_back(1);

  char temp_sc_service_time_[100];
  char temp_sc_completed_clients_[100];
  char temp_sc_evolution_chunks_[100];
  char temp_sc_packet_emitted_[100];
  char temp_sc_packet_useless_[100];

 if (source_place == 'r') {

    strcpy(temp_sc_service_time_,sc_service_time_);
    if (nb_sources == 1) {
      strcat(temp_sc_service_time_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_service_time_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_service_time_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_service_time_,"_4r.m");
    }

    strcpy(temp_sc_completed_clients_,sc_completed_clients_);
    if (nb_sources == 1) {
      strcat(temp_sc_completed_clients_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_completed_clients_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_completed_clients_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_completed_clients_,"_4r.m");
    }

    strcpy(temp_sc_evolution_chunks_,sc_evolution_chunks_);
    if (nb_sources == 1) {
      strcat(temp_sc_evolution_chunks_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_evolution_chunks_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_evolution_chunks_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_evolution_chunks_,"_4r.m");
    }

    strcpy(temp_sc_packet_emitted_,sc_packet_emitted_);
    if (nb_sources == 1) {
    strcat(temp_sc_packet_emitted_,"_r.m");
    } 
    if (nb_sources == 2) {
    strcat(temp_sc_packet_emitted_,"_2r.m");
    }
    if (nb_sources == 3) {
    strcat(temp_sc_packet_emitted_,"_3r.m");
    }
    if (nb_sources == 4) {
    strcat(temp_sc_packet_emitted_,"_4r.m");
    }

    strcpy(temp_sc_packet_useless_,sc_packet_useless_);
    if (nb_sources == 1) {
      strcat(temp_sc_packet_useless_,"_r.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_packet_useless_,"_2r.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_packet_useless_,"_3r.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_packet_useless_,"_4r.m");
    }

  }

 if (source_place == 'e') {

    strcpy(temp_sc_service_time_,sc_service_time_);
    if (nb_sources == 1) {
      strcat(temp_sc_service_time_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_service_time_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_service_time_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_service_time_,"_4e.m");
    }

    strcpy(temp_sc_completed_clients_,sc_completed_clients_);
    if (nb_sources == 1) {
      strcat(temp_sc_completed_clients_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_completed_clients_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_completed_clients_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_completed_clients_,"_4e.m");
    }

    strcpy(temp_sc_evolution_chunks_,sc_evolution_chunks_);
    if (nb_sources == 1) {
      strcat(temp_sc_evolution_chunks_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_evolution_chunks_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_evolution_chunks_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_evolution_chunks_,"_4e.m");
    }

    strcpy(temp_sc_packet_emitted_,sc_packet_emitted_);
    if (nb_sources == 1) {
    strcat(temp_sc_packet_emitted_,"_e.m");
    } 
    if (nb_sources == 2) {
    strcat(temp_sc_packet_emitted_,"_2e.m");
    }
    if (nb_sources == 3) {
    strcat(temp_sc_packet_emitted_,"_3e.m");
    }
    if (nb_sources == 4) {
    strcat(temp_sc_packet_emitted_,"_4e.m");
    }

    strcpy(temp_sc_packet_useless_,sc_packet_useless_);
    if (nb_sources == 1) {
      strcat(temp_sc_packet_useless_,"_e.m");
    } 
    if (nb_sources == 2) {
      strcat(temp_sc_packet_useless_,"_2e.m");
    }
    if (nb_sources == 3) {
      strcat(temp_sc_packet_useless_,"_3e.m");
    }
    if (nb_sources == 4) {
      strcat(temp_sc_packet_useless_,"_4e.m");
    }

  }

  ofstream time_slot(temp_sc_service_time_, ios::out);
  if (!time_slot) {
    cerr << "the file service_time_ could not be opened" << endl;
  }
  time_slot << "time_slot = [";

  ofstream completed_clients_(temp_sc_completed_clients_, ios::out);
  if (!completed_clients_) {
    cerr << "the file sc_completed_clients_ could not be opened" << endl;
  }
  completed_clients_ << "sc_completed_clients_ = [";

  ofstream out_allchunks(temp_sc_evolution_chunks_, ios::out);
  if (!out_allchunks) {
    cerr << "the file evolution_chunks could not be opened" << endl;
  }
  out_allchunks << "sc_evolution_chunks_ = [";

  ofstream packet_emitted_(temp_sc_packet_emitted_, ios::out);
  if (!packet_emitted_) {
    cerr << "the file packet_emitted could not be opened" << endl;
  }
  packet_emitted_ << "sc_packet_emitted_ =[";
  
  ofstream packet_useless_(temp_sc_packet_useless_, ios::out);
  if (!packet_useless_) {
    cerr << "the file packet_useless_ could not be opened" << endl;
  }
  packet_useless_ << "sc_packet_useless_ = [";
  
  sc_create_nodes_();
  sc_generate_xy();
  

  for (int a=0; a<nb_chunks_+1; a++) {
    out_allchunks << all_chunks_[a] << " ";
  }
  out_allchunks << endl;
  completed_clients_ << nb_nodes_ - missing_nodes_.size() << " ";
  packet_emitted_ << packet_emitted << " ";
  packet_useless_ << packet_received - packet_useful << " ";
  time_slot << service_time << " ";
  
  cout << "\n________________________" << endl;
  cout << "start selective coding" << endl;
  while ((missing_nodes_.size() > 0) && (candidates_queue_.size() > 0)) {
    cout << "run sc_select_transmitters" << endl;
    sc_select_transmitters();
    cout << "run sc_perform_transmission" << endl;
    sc_perform_transmission();
    
    service_time = service_time + 1.0/nb_chunks_;

    for (int a=0; a<nb_chunks_+1; a++) {
      out_allchunks << all_chunks_[a] << " ";
    }
    out_allchunks << endl;
    completed_clients_ << nb_nodes_ - missing_nodes_.size() << " ";
    packet_emitted_ << packet_emitted << " ";
    packet_useless_ << packet_received - packet_useful << " ";
    time_slot << service_time << " ";
  }
  cout << "end of selective coding\n" << endl;

  time_slot << "]; \n\n";
  time_slot.close();
  completed_clients_ << "]; \n\n";
  completed_clients_.close();
  out_allchunks << "]; \n\n";
  out_allchunks.close();
  packet_emitted_ << "]; \n\n";
  packet_emitted_.close();
  packet_useless_ << "]; \n\n";
  packet_useless_.close();
  for (int i=0; i<nb_nodes_; i++) {
    delete sc_list_nodes_[i];
  }
  missing_nodes_.clear();
  ready_queue_.clear();
  candidates_queue_.clear();
  receiving_queue_.clear();
  sc_list_nodes_.clear();
}
